=== src/svxlink/modules/CMakeLists.txt ===
#add_subdirectory(template)
add_subdirectory(help)
add_subdirectory(parrot)
add_subdirectory(echolink)
add_subdirectory(tcl)
add_subdirectory(tcl_voice_mail)
add_subdirectory(dtmf_repeater)
add_subdirectory(metarinfo)
add_subdirectory(propagation_monitor)
add_subdirectory(selcallenc)
add_subdirectory(frn)
add_subdirectory(trx)
