=== debian/changelog ===
svxlink (24.02-5) unstable; urgency=medium

  * Revert dh_installsysusers change, was not tested enough.
  * Pre-Depend on adduser instead. (Closes: #1104571)

 -- Christoph Berg <myon@debian.org>  Wed, 14 May 2025 20:47:33 +0000

svxlink (24.02-4) unstable; urgency=medium

  * Drop adduser from preinst scripts, use dh_installsysusers instead.
    (Closes: #1104571)

 -- Christoph Berg <myon@debian.org>  Fri, 02 May 2025 22:56:20 +0200

svxlink (24.02-3) unstable; urgency=medium

  * Disable units from starting at boottime to avoid taking sole ownership of
    sound devices
    * Closes: #1075840

 -- Dave Hibberd <hibby@debian.org>  Fri, 12 Jul 2024 19:41:30 +0100

svxlink (24.02-2) unstable; urgency=medium

  * B-D on libgpiod based on user feedback
  * Remove references to lsb-base as it is obsolete
  * Bump Standards to 4.7.0, no changes
  * Bump debian/watch to ver 4
  * I'll take over as uploader to satisfy lintian

 -- Dave Hibberd <hibby@debian.org>  Tue, 18 Jun 2024 21:27:44 +0100

svxlink (24.02-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Update lintian override info to new format on line 2.
  * Refer to common license file for CC0-1.0.
  * Use secure URI in Homepage field.
  * Update renamed lintian tag names in lintian overrides.
  * Set upstream metadata fields: Archive, Bug-Database, Bug-Submit,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Christoph Berg ]
  * New upstream version 24.02.
  * B-D on libjsoncpp-dev.
  * B-D on dh-sequence-movetousr.

 -- Christoph Berg <myon@debian.org>  Sun, 19 May 2024 16:25:31 +0200
